VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "brPort"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' CAPE-OPEN Unit Bridge (c) 2001 Joerg Koeller

' Example client for the bridged unit(c) 2001 Joerg Koeller
' original corba idl source file is a modified CO v0.92 CIDL

' CAUTION: This software comes without any warranty whatsoever.
' You use this software at your very own risk. The author is
' is not responsible for any damage cause directly or indirectly
' by the use of this software.

' This software may be used for educational purposes only. Any
' commercial use neither as source code nor as binary even in
' parts or modified form is strictly
' prohibited and requires a written permission by the author.
' You can contact the author via e-mail: mandrox@web.deOption Explicit
Option Explicit

Implements CAPEOPEN.ICapeUnitPort
Implements CAPEOPEN.ICapeIdentification

Private cbObjRef As cOrbObjRef
Private cbObject As c_UnitPort


Friend Sub initCB(externalRef As String)

    If (myOrb Is Nothing) Then
        Set myOrb = VBOrb.init
    End If
    
    Set cbObjRef = retrieveObject(externalRef)
    
    Set cbObject = m_UnitPort.narrow(cbObjRef)
           
End Sub

Friend Sub initCBobj(cbObj As cOrbObject)
    Set cbObject = m_UnitPort.narrow(cbObj)
End Sub

Private Property Let ICapeIdentification_ComponentDescription(ByVal RHS As String)
    cbObject.SetComponentDescription RHS
End Property

Private Property Get ICapeIdentification_ComponentDescription() As String
    ICapeIdentification_ComponentDescription = cbObject.GetComponentDescription
End Property

Private Property Let ICapeIdentification_ComponentName(ByVal RHS As String)
    cbObject.SetComponentName RHS
End Property

Private Property Get ICapeIdentification_ComponentName() As String
    ICapeIdentification_ComponentName = cbObject.GetComponentName
End Property


Private Function ICapeUnitPort_Connect(ByVal objectToConnect As Object, message As String) As Boolean
   Dim newCBMo As cbMatObjImpl
   
   Set newCBMo = New cbMatObjImpl
   Call myOrb.connect(newCBMo)
   newCBMo.setComObj objectToConnect
       
   Dim connCBObj As c_MatObj
   Set connCBObj = m_MatObj.narrow(newCBMo.ObjRef)
   
   message = ""
   
   cbObject.connect connCBObj
   
   ICapeUnitPort_Connect = True
End Function


Private Property Get ICapeUnitPort_connectedObject() As Object
  Dim connCBObj As c_MatObj
  Set connCBObj = cbObject.GetConnectedObject
  
  Dim newComMO As brMatObj
  Set newComMO = New brMatObj 'CreateObject("unitBridge.brMatObj")
  newComMO.initCBobj connCBObj
  
  Set ICapeUnitPort_connectedObject = newComMO
End Property

Private Property Get ICapeUnitPort_direction() As Long
  ICapeUnitPort_direction = cbObject.GetDirection()
End Property

Private Function ICapeUnitPort_Disconnect(message As String) As Boolean
   cbObject.disconnect
   message = ""
   ICapeUnitPort_Disconnect = True
End Function


Private Property Get ICapeUnitPort_portType() As Long
   ICapeUnitPort_portType = cbObject.GetType()
End Property

