VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "brPortCollection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' CAPE-OPEN Unit Bridge (c) 2001 Joerg Koeller

' Example client for the bridged unit(c) 2001 Joerg Koeller
' original corba idl source file is a modified CO v0.92 CIDL

' CAUTION: This software comes without any warranty whatsoever.
' You use this software at your very own risk. The author is
' is not responsible for any damage cause directly or indirectly
' by the use of this software.

' This software may be used for educational purposes only. Any
' commercial use neither as source code nor as binary even in
' parts or modified form is strictly
' prohibited and requires a written permission by the author.
' You can contact the author via e-mail: mandrox@web.deOption Explicit
Option Explicit

Implements CAPEOPEN.ICapeUnitCollection
Implements CAPEOPEN.ICapeIdentification

Private cbObjRef As cOrbObjRef
Private cbObject As c_PortColl

Friend Sub initCB(externalRef As String)

    If (myOrb Is Nothing) Then
        Set myOrb = VBOrb.init(VisiWorkaround:=True)
    End If
    
    Set cbObjRef = retrieveObject(externalRef)
    
    Set cbObject = m_PortColl.narrow(cbObjRef)
           
End Sub
Friend Sub initCBobj(cbObj As cOrbObject)
    Set cbObject = m_PortColl.narrow(cbObj)
End Sub
Private Property Let ICapeIdentification_ComponentDescription(ByVal RHS As String)
    cbObject.SetComponentDescription RHS
End Property

Private Property Get ICapeIdentification_ComponentDescription() As String
    ICapeIdentification_ComponentDescription = cbObject.GetComponentDescription
End Property

Private Property Let ICapeIdentification_ComponentName(ByVal RHS As String)
    cbObject.SetComponentName RHS
End Property

Private Property Get ICapeIdentification_ComponentName() As String
    ICapeIdentification_ComponentName = cbObject.GetComponentName
End Property

Private Function ICapeUnitCollection_Count() As Long
   ICapeUnitCollection_Count = cbObject.Count
End Function

Private Function ICapeUnitCollection_Item(ByVal id As Variant) As Object
    
    Dim cbItemObj As cOrbObject
    Dim cbItemObjRef As cOrbObjRef
       
    Dim ccPort As brPort
    
    On Error GoTo handler
    
    
' CORBA IDL v0.9.3 only!
' Needs ICapeUnitCollection instead of Parm and Port collections
'    If (VarType(id) = vbString) Then
'      Set cbItemObj = cbObject.ItemByName(id)
'    ElseIf ((VarType(id) = vbLong) Or (VarType(id) = vbInteger)) Then
'      Set cbItemObj = cbObject.ItemByIndex(id)
'    Else
'      Err.Raise CAPEOPEN.ECapeInvalidArgumentHR
'    End If

' CORBA IDL v0.9.2 only!
    If ((VarType(id) = vbLong) Or (VarType(id) = vbInteger)) Then
      Set cbItemObj = cbObject.Item(id)
    Else
      Err.Raise vbObjectError
    End If
    
    
    
    Dim myPort As c_UnitPort
    Dim i As String
    
    Set cbItemObjRef = cbItemObj.getObjRef
    
    Set myPort = m_UnitPort.narrow(cbItemObjRef)
    
      
    Set ccPort = New brPort
    ccPort.initCBobj cbItemObjRef
        
    Set ICapeUnitCollection_Item = ccPort
    
    Exit Function


handler:
    Err.Raise vbObjectError

End Function

