VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "brBooleanParameterSpec"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements CAPEOPEN.ICapeIdentification
Implements CAPEOPEN.ICapeParameterSpec
Implements CAPEOPEN.ICapeBooleanParameterSpec

Private cbObjRef As cOrbObjRef
Private cbObject As c_ICapeBooleanParameterSpec

Friend Sub initCB(externalRef As String)

    If (myOrb Is Nothing) Then
        Set myOrb = VBOrb.init
    End If
    
    Set cbObjRef = retrieveObject(externalRef)
    
    Set cbObject = m_ICapeBooleanParameterSpec.narrow(cbObjRef)
           
End Sub

Friend Sub initCBobj(cbObj As cOrbObject)
    Set cbObject = m_ICapeBooleanParameterSpec.narrow(cbObj)
End Sub

Private Sub Class_Initialize()
    If (cbUnitReference Is Nothing) Then
      Err.Raise ECapeFailedInitialisationHR
    End If
End Sub

Private Property Get ICapeBooleanParameterSpec_DefaultValue() As Boolean
    ICapeBooleanParameterSpec_DefaultValue = cbObject.GetDefaultValue
End Property

Private Function ICapeBooleanParameterSpec_Validate(ByVal value As Boolean, message As String) As Boolean
    On Error GoTo handler
    Dim myValRes As Boolean
    
    myValRes = cbObject.Validate(value, message)
    
    ICapeBooleanParameterSpec_Validate = myValRes
    
    Exit Function
handler:
    ICapeBooleanParameterSpec_Validate = False

End Function

Private Property Let ICapeIdentification_ComponentDescription(ByVal RHS As String)
    cbObject.SetComponentDescription RHS
End Property

Private Property Get ICapeIdentification_ComponentDescription() As String
    ICapeIdentification_ComponentDescription = cbObject.GetComponentDescription
End Property

Private Property Let ICapeIdentification_ComponentName(ByVal RHS As String)
    cbObject.SetComponentName RHS
End Property

Private Property Get ICapeIdentification_ComponentName() As String
    ICapeIdentification_ComponentName = cbObject.GetComponentName
End Property

Private Property Get ICapeParameterSpec_Dimensionality() As Variant
' This property is currently not properly implemented because VBOrb
' does not support complex Any types (e.g. containing an array or sequence
' Possible workaround: Introduce a CORBA Any translator which encapsulates
' a sequence in an object. This object could be put into an Any which then
' is accessible by VBOrb
' Current implementation returns an array of long filled with 0
    
    Dim myVal(1 To 7) As Long
    
    ICapeParameterSpec_Dimensionality = myVal
    
End Property

Private Property Get ICapeParameterSpec_Type() As CAPEOPEN.CapeParamType
    ICapeParameterSpec_Type = cbObject.GetType
End Property

