VERSION 5.00
Begin VB.Form timerForm 
   Caption         =   "COM-CORBA Unit Bridge Set-Up"
   ClientHeight    =   2310
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7680
   LinkTopic       =   "Form1"
   ScaleHeight     =   2310
   ScaleWidth      =   7680
   StartUpPosition =   3  'Windows-Standard
   Visible         =   0   'False
   Begin VB.Frame Frame1 
      Height          =   1815
      Left            =   0
      TabIndex        =   5
      Top             =   240
      Width           =   2055
      Begin VB.Label Label3 
         Alignment       =   2  'Zentriert
         Caption         =   "Unit Bridge Prototype"
         Height          =   375
         Left            =   240
         TabIndex        =   8
         Top             =   480
         Width           =   1575
      End
      Begin VB.Label Label2 
         Alignment       =   2  'Zentriert
         Caption         =   "CAPE-OPEN"
         Height          =   375
         Left            =   120
         TabIndex        =   7
         Top             =   240
         Width           =   1815
      End
      Begin VB.Label Label5 
         Alignment       =   2  'Zentriert
         Caption         =   "Educational use only!"
         Height          =   255
         Left            =   240
         TabIndex        =   10
         Top             =   1320
         Width           =   1575
      End
      Begin VB.Label Label4 
         Alignment       =   2  'Zentriert
         Caption         =   "(C) 2001 Jrg Kller"
         Height          =   255
         Left            =   240
         TabIndex        =   9
         Top             =   840
         Width           =   1575
      End
   End
   Begin VB.Frame Frame2 
      Height          =   1750
      Left            =   6480
      TabIndex        =   6
      Top             =   300
      Width           =   1095
      Begin VB.Image Image2 
         Height          =   1560
         Left            =   45
         Picture         =   "timerForm.frx":0000
         Stretch         =   -1  'True
         Top             =   135
         Width           =   1005
      End
   End
   Begin VB.CommandButton cancelBtn 
      Caption         =   "Cancel"
      Height          =   495
      Left            =   4440
      TabIndex        =   3
      Top             =   1560
      Width           =   1815
   End
   Begin VB.CommandButton okBtn 
      Caption         =   "OK"
      Height          =   495
      Left            =   2160
      TabIndex        =   2
      Top             =   1560
      Width           =   1815
   End
   Begin VB.TextBox Text1 
      Height          =   375
      Left            =   2160
      TabIndex        =   1
      Text            =   "file://d:\dev\iors\unit.ior"
      Top             =   600
      Width           =   4095
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   50
      Left            =   0
      Top             =   2880
   End
   Begin VB.Label errorLabel 
      ForeColor       =   &H000000FF&
      Height          =   375
      Left            =   2160
      TabIndex        =   4
      Top             =   1080
      Width           =   4335
   End
   Begin VB.Label Label1 
      Caption         =   "Please enter valid CORBA v0.9.2 UNIT reference:"
      Height          =   255
      Left            =   2160
      TabIndex        =   0
      Top             =   240
      Width           =   4215
   End
End
Attribute VB_Name = "timerForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' CAPE-OPEN Unit Bridge (c) 2001 Joerg Koeller

' CAUTION: This software comes without any warranty whatsoever.
' You use this software at your very own risk. The author is
' is not responsible for any damage cause directly or indirectly
' by the use of this software.

' This software may be used for educational purposes only. Any
' commercial use neither as source code nor as binary even in
' parts or modified form is strictly
' prohibited and requires a written permission by the author.
' You can contact the author via e-mail: mandrox@web.de
Private Sub cancelBtn_Click()
    unitOK = False
    timerForm.Hide
End Sub

Private Sub Form_Load()
    Timer1.Enabled = True
End Sub

Private Sub okBtn_Click()
    unitOK = False
    On Error GoTo handler
    Dim cbObjRef As cOrbObjRef
    Set cbObjRef = myOrb.stringToObject(timerForm.Text1.Text)
    Set cbUnitReference = m_ICapeUnit.narrow(cbObjRef)
    unitOK = True
    'errorLabel.Caption = "Reference OK. Unit retrieved."
    timerForm.Hide
    Exit Sub
handler:
    errorLabel.Caption = "This is NOT a valid CORBA v0.9.2 UNIT reference!"
End Sub

Private Sub Timer1_Timer()
    myOrb.performWork 50
End Sub
